# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from project.forms.fields.extras.enable import EnableField


##############################################################################
class CheckboxField(forms.BooleanField):
    #widget = forms.widgets.CheckboxInput
    #default_validators = []
    #default_error_messages = {
    #    'required': _(u'This field is required.'),
    #    'invalid': _(u'Enter a valid value.'),
    #}

    def __init__(self,
                 required=False,
                 *args, **kwargs):
        super(CheckboxField, self).__init__(required=required,
                                            *args, **kwargs)


class WeekdaysCheckboxMultipleField(forms.MultipleChoiceField):

    widget = forms.CheckboxSelectMultiple

    def __init__(self,
                 widget=widget,
                 choices=[(d.lower(), _(d)) for d in (u"Sun",
                                                      u"Mon",
                                                      u"Tue",
                                                      u"Wed",
                                                      u"Thu",
                                                      u"Fri",
                                                      u"Sat")],
                 *args, **kwargs):
        super(WeekdaysCheckboxMultipleField, self).__init__(widget=widget,
                                                            choices=choices,
                                                            *args, **kwargs)
##############################################################################


#class ReplicationScheduleEnabledField(CheckboxField):
class ReplicationScheduleEnabledField(EnableField):

    def __init__(self,
                 label=_(u"REPLICATION: LABEL: ReplicationScheduleEnabledField"),
                 *args, **kwargs):
        super(ReplicationScheduleEnabledField, self).__init__(label=label,
                                                              *args, **kwargs)


class ReplicationScheduleWeekdaysField(WeekdaysCheckboxMultipleField):

    def __init__(self,
                 label=_(u"REPLICATION: LABEL: ReplicationScheduleWeekdaysField"),
                 *args, **kwargs):
        super(ReplicationScheduleWeekdaysField, self).__init__(label=label,
                                                               *args, **kwargs)


class ReplicationScheduleTimeField(forms.TimeField):

    widget = forms.TimeInput
    input_formats = ["%H:%M"]

    def __init__(self,
                 label=_(u"REPLICATION: LABEL: ReplicationScheduleTimeField"),
                 widget=widget(format=input_formats[0]),
                 input_formats=input_formats,
                 *args, **kwargs):
        super(ReplicationScheduleTimeField, self).__init__(label=label,
                                                           widget=widget,
                                                           input_formats=input_formats,
                                                           *args, **kwargs)
